//
//  MCtableView.h
//  Tools
//
//  Created by ike on 2017/1/17.
//  Copyright © 2017年 ike. All rights reserved.
//

#import <UIKit/UIKit.h>

@class MCtCell;
typedef void(^McReturnCellIndexPath)(NSIndexPath *indexPath,MCtCell *cell);
typedef void(^ReturnTableViewScroll)(CGFloat scroll);
typedef void(^McReturnCellSelendIndexPath)(UIButton *button,NSInteger mcTag,NSIndexPath *indexPath,id data);
@interface MCtableView : UITableView
/**
 加载视图
 style 风格
 */
+(MCtableView *)mcDefaultMCTableViewVC:(UIViewController *)Controler CGFrame:(CGRect)frame TableViewStyle:(UITableViewStyle)style;
/**
 mcSection:第几个区
 mcRows:多少个Rows
 */
-(MCtableView *(^)(NSInteger mcSection,NSInteger mcRows))mcDataSource;

@property(nonatomic,copy)McReturnCellIndexPath mcData;
@property(nonatomic,copy)McReturnCellSelendIndexPath mcSelendData;
@property(nonatomic, copy)ReturnTableViewScroll mcScroll;
/**
 设置区头的高度
 selend 添加点击事件默认为NO
 allData 全区都有
 */
-(MCtableView *(^)(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view))mcHeader;
/**
 删除区头
 */
-(MCtableView *(^)(NSInteger mcSection))mcRemoveHeader;
/**
 删除区尾
 */
-(MCtableView *(^)(NSInteger mcSection))mcRemoveFooter;
/**
 设置区尾的高度
 selend 添加点击事件默认为NO
 allData 全区都有
 */
-(MCtableView *(^)(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view))mcFooter;
/**
 返回 mcIndexPath---->Cell
 block 编辑Cell
 blockData 点击事件回调 如:区头---> 1000 区尾---->2000
 */
-(void)mcReturnCellIndexPath:(McReturnCellIndexPath)block SelendIndexPath:(McReturnCellSelendIndexPath)blockData;

/**
 根据返回的mcIndexPath 展示Cell
 mcIndexPath 当前区域 indexPath
 cell  当前区域的 cell
 */
-(MCtableView *(^)(NSIndexPath *mcIndexPath,MCtCell *cell))mcSetShowCell;

/**
 监听滑动
 */
-(void)mcRetuenidScroll:(ReturnTableViewScroll)block;
@end

typedef void(^McReturnCellData)(UIButton *button,NSInteger mcTag,id data);
@interface MCtCell : UITableViewCell
@property (weak, nonatomic) IBOutlet UILabel *title;
@property (weak, nonatomic) IBOutlet UILabel *orderId;
@property (weak, nonatomic) IBOutlet UILabel *state;
@property (weak, nonatomic) IBOutlet UILabel *name;
@property (weak, nonatomic) IBOutlet UILabel *prName;
@property (weak, nonatomic) IBOutlet UILabel *price;
@property (weak, nonatomic) IBOutlet UILabel *count;
@property (weak, nonatomic) IBOutlet UIView *btmLine;
@property(nonatomic,strong)McReturnCellData mcDataCell;
-(void)mcReturnCellData:(McReturnCellData)block;
@end
