//
//  MCtableView.m
//  Tools
//
//  Created by ike on 2017/1/17.
//  Copyright © 2017年 ike. All rights reserved.
//

#import "MCtableView.h"

@interface MCtableView ()<UITableViewDelegate,UITableViewDataSource>{
    NSMutableDictionary *mcSectionRows;
    NSMutableDictionary *allHeaderFooterSection;
    /**
     监听滑动
     */
    NSInteger scrollSign;
}

@end

@implementation MCtableView

-(void)awakeFromNib{
    [super awakeFromNib];
    self.delegate = self;
    self.dataSource = self;
    mcSectionRows = [NSMutableDictionary dictionaryWithCapacity:0];
    allHeaderFooterSection = [NSMutableDictionary dictionaryWithCapacity:0];
}
-(MCtableView *(^)(NSInteger mcSection,NSInteger mcRows))mcDataSource{
    return ^MCtableView *(NSInteger mcSection,NSInteger mcRows){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcSection)]];
        [mcSectionDict setObject:@(mcRows) forKey:@"Rows"];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcSection)];
        return self;
    };
}
/**
 监听滑动
 */
-(void)mcRetuenidScroll:(ReturnTableViewScroll)block{
    scrollSign = 1;
    self.mcScroll = block;
}
-(MCtableView *(^)(NSIndexPath * mcIndexPath,MCtCell *cell))mcSetShowCell{
    return ^MCtableView *(NSIndexPath * mcIndexPath,MCtCell *cell){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcIndexPath.section)]];
        [mcSectionDict setObject:cell forKey:@(mcIndexPath.row)];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcIndexPath.section)];
        return self;
    };
}
/**
 设置区头的高度
 selend 添加点击事件默认为NO
 */
-(MCtableView *(^)(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view))mcHeader{
    return ^MCtableView *(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcSection)]];
        NSMutableDictionary *headerDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionDict[@"header"]];
        [headerDict setObject:@(HeaderHeight) forKey:@"height"];
        [headerDict setObject:view forKey:@"view"];
        if (selend == YES){
            [headerDict setObject:@"Yes" forKey:@"bool"];
        }else{
            [headerDict removeObjectForKey:@"bool"];
        }
        [mcSectionDict setObject:headerDict forKey:@"header"];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcSection)];
        return self;
    };
}
/**
 删除区头
 */
-(MCtableView *(^)(NSInteger mcSection))mcRemoveHeader{
    return ^MCtableView *(NSInteger mcSection){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcSection)]];
        [mcSectionDict removeObjectForKey:@"header"];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcSection)];
        return self;
    };
}
/**
 删除区尾
 */
-(MCtableView *(^)(NSInteger mcSection))mcRemoveFooter{
    return ^MCtableView *(NSInteger mcSection){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcSection)]];
        [mcSectionDict removeObjectForKey:@"footer"];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcSection)];
        return self;
    };
}
/**
 设置区尾的高度
 selend 添加点击事件默认为NO
 */
-(MCtableView *(^)(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view))mcFooter{
    return ^MCtableView *(NSInteger mcSection,CGFloat HeaderHeight,BOOL selend,UIView *view){
        NSMutableDictionary *mcSectionDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionRows[@(mcSection)]];
        NSMutableDictionary *headerDict = [NSMutableDictionary dictionaryWithDictionary:mcSectionDict[@"footer"]];
        [headerDict setObject:@(HeaderHeight) forKey:@"height"];
        [headerDict setObject:view forKey:@"view"];
        if (selend == YES){
            [headerDict setObject:@"Yes" forKey:@"bool"];
        }else{
            [headerDict removeObjectForKey:@"bool"];
        }
        
        [mcSectionDict setObject:headerDict forKey:@"footer"];
        [mcSectionRows setObject:mcSectionDict forKey:@(mcSection)];
        return self;
    };
}


/**
 返回 mcIndexPath---->Cell
 block 编辑Cell
 blockData 点击事件回调 如:区头---> 1000 区尾---->2000
 */
-(void)mcReturnCellIndexPath:(McReturnCellIndexPath)block SelendIndexPath:(McReturnCellSelendIndexPath)blockData{
    self.mcData = block;
    self.mcSelendData = blockData;
}
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return [mcSectionRows allKeys].count;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{//如果数组是字典{section:array}
    return [mcSectionRows[@(section)][@"Rows"] intValue];
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    NSString *idCell = [NSString stringWithFormat:@"%ld,%ld",(long)indexPath.section,(long)indexPath.row];
    MCtCell *cell = [tableView dequeueReusableCellWithIdentifier:idCell];
    cell = mcSectionRows[@(indexPath.section)][@(indexPath.row)];
    if (!cell){
        self.mcData(indexPath,cell);
    }
    [cell mcReturnCellData:^(UIButton *button, NSInteger mcTag, id data) {
        self.mcSelendData(button,mcTag,indexPath,data);
    }];
    return cell;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    MCtCell *cell = (MCtCell *)[self tableView:tableView cellForRowAtIndexPath:indexPath];
    return cell.frame.size.height;
}
-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section{
    if ([[allHeaderFooterSection allKeys] containsObject:@"footer"]) {
        return [allHeaderFooterSection[@"footer"][@"height"] floatValue];
    }else{
        if ([[mcSectionRows allKeys] containsObject:@(section)]) {
            NSDictionary *sectionDict = [NSDictionary dictionaryWithDictionary:mcSectionRows[@(section)]];
            if ([[sectionDict allKeys] containsObject:@"footer"]) {
                NSDictionary *footerDict = [NSDictionary dictionaryWithDictionary:sectionDict[@"footer"]];
                return [footerDict[@"height"] floatValue];
            }else{
                return 0.001;
            }
        }else{
            return 0.001;
        }
    }
    
}
-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section{
    if ([[allHeaderFooterSection allKeys] containsObject:@"header"]) {
        return [allHeaderFooterSection[@"header"][@"height"] floatValue];
    }else{
        if ([[mcSectionRows allKeys] containsObject:@(section)]) {
            NSDictionary *sectionDict = [NSDictionary dictionaryWithDictionary:mcSectionRows[@(section)]];
            if ([[sectionDict allKeys] containsObject:@"header"]){
                NSDictionary *footerDict = [NSDictionary dictionaryWithDictionary:sectionDict[@"header"]];
                return [footerDict[@"height"] floatValue];
            }else{
                return 0.001;
            }
        }else{
            return 0.001;
        }
    }
    
}
-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section{
    NSDictionary *sectionDict = [NSDictionary dictionaryWithDictionary:mcSectionRows[@(section)]];
    NSDictionary *footerDict = [NSDictionary dictionaryWithDictionary:sectionDict[@"header"]];
    if ([[allHeaderFooterSection allKeys] containsObject:@"header"]) {
        footerDict = [NSDictionary dictionaryWithDictionary:allHeaderFooterSection[@"header"]];
    }
    MCtCell *view = footerDict[@"view"];
    if ([[footerDict allKeys] containsObject:@"bool"]){
        view.tag = section;
        UITapGestureRecognizer* singleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(headerSingleTap:)];
        [view addGestureRecognizer:singleTap];
    }
    [view mcReturnCellData:^(UIButton *button, NSInteger mcTag, id data) {
        self.mcSelendData(button,mcTag,[NSIndexPath indexPathForRow:1000 inSection:section],data);
    }];
    return view;
}
-(UIView *)tableView:(UITableView *)tableView viewForFooterInSection:(NSInteger)section{
    NSDictionary *sectionDict = [NSDictionary dictionaryWithDictionary:mcSectionRows[@(section)]];
    NSDictionary *footerDict = [NSDictionary dictionaryWithDictionary:sectionDict[@"footer"]];
    if ([[allHeaderFooterSection allKeys] containsObject:@"footer"]) {
        footerDict = [NSDictionary dictionaryWithDictionary:allHeaderFooterSection[@"footer"]];
    }
    MCtCell *view = footerDict[@"view"];
    if ([[footerDict allKeys] containsObject:@"bool"]){
        view.tag = section;
        UITapGestureRecognizer* singleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(footerSingleTap:)];
        [view addGestureRecognizer:singleTap];
    }
    [view mcReturnCellData:^(UIButton *button, NSInteger mcTag, id data) {
        self.mcSelendData(button,mcTag,[NSIndexPath indexPathForRow:2000 inSection:section],data);
    }];
    return view;
}
-(void)scrollToRowAtIndexPath:(NSIndexPath *)indexPath atScrollPosition:(UITableViewScrollPosition)scrollPosition animated:(BOOL)animated{
    NSLog(@"---------------->%ld,%ld",indexPath.section,indexPath.row);
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
     [tableView deselectRowAtIndexPath:indexPath animated:NO];
    self.mcSelendData(nil,0,indexPath,nil);
}
-(void)footerSingleTap:(UITapGestureRecognizer *)sender{
    self.mcSelendData(nil,0,[NSIndexPath indexPathForRow:2000 inSection:[sender view].tag],nil);
}
-(void)headerSingleTap:(UITapGestureRecognizer *)sender{
    self.mcSelendData(nil,0,[NSIndexPath indexPathForRow:1000 inSection:[sender view].tag],nil);
}
- (void)scrollViewDidScroll:(UIScrollView *)scrollView{
    if (scrollSign == 1) {
        self.mcScroll(scrollView.contentOffset.y);
    }
}
+(MCtableView *)mcDefaultMCTableViewVC:(UIViewController *)Controler CGFrame:(CGRect)frame TableViewStyle:(UITableViewStyle)style{
    MCtableView *tableView;
    if(style == UITableViewStylePlain){
        tableView = [[[NSBundle mainBundle]loadNibNamed:@"MCtableView" owner:self options:nil]objectAtIndex:0];
    }else{
        tableView = [[[NSBundle mainBundle]loadNibNamed:@"MCtableView" owner:self options:nil]objectAtIndex:1];
    }
    tableView.frame = frame;
    [Controler.view addSubview:tableView];
    return tableView;
}

@end

@interface MCtCell ()

@end

@implementation MCtCell

-(void)awakeFromNib{
    [super awakeFromNib];
}
-(void)mcReturnCellData:(McReturnCellData)block{
    self.mcDataCell = block;
}
@end
